#ifndef _AVCSEQUENCE_H_
#define _AVCSEQUENCE_H_

class AVCSequence {

private:
	enum {
		CHROMA420 = 1,
		CHROMA422 = 2,
		CHROMA444 = 3
	};

	const unsigned char *bits;

	unsigned int  len;
	unsigned int  pos;

	unsigned char curbyte;
	unsigned char curbit;
	unsigned char error;

	unsigned char profile_idc;
	unsigned char separate_colour_plane_flag;
	unsigned char frame_mbs_only_flag;

	unsigned char ChromaArrayType;
	unsigned char SubWidthC;
	unsigned char SubHeightC;
	unsigned char CropUnitX;
	unsigned char CropUnitY;

	unsigned int  chroma_format_idc;
	unsigned int  pic_width_in_mbs_minus1;
	unsigned int  pic_height_in_map_units_minus1;

	unsigned int  frame_crop_left_offset;
	unsigned int  frame_crop_right_offset;
	unsigned int  frame_crop_top_offset;
	unsigned int  frame_crop_bottom_offset;

	unsigned char next_bit();

	unsigned int  get_bits(int n);
	unsigned int  get_ue_golomb();
	int           get_se_golomb();
	void          scaling_list(int sizeOfScalingList);
	void          Reset();

public:
	AVCSequence()
		: bits (NULL)
		, len  (0)
	{
		Reset();
	}

	bool ParseSPS(const void *data, int size);

	int  Width () const;
	int  Height() const;
};

#endif  // _AVCSEQUENCE_H_

