#ifndef _VIDEOCODEC_H_
#define _VIDEOCODEC_H_


class VideoCodec {

private:
	typedef struct OUTPUTFORMAT {
		BITMAPINFOHEADER	bmih;
		DWORD				bmiColors[3];
	};

	unsigned char *bmihIn;
	OUTPUTFORMAT bmihOut;

	bool SetInputFormat(const BITMAPINFOHEADER *in);
	bool QueryOutputFormat(int format);
	bool LockFormat(int format, const OUTPUTFORMAT *bmih);
	bool QueryDecompressor(BITMAPINFOHEADER *out);

public:
	VideoCodec();
	~VideoCodec();

// We are trusting our host NOT to modify these!
	HIC hCodec;
	VDXPixmap mPixmap;
	unsigned char *mFrameBuffer;

	bool Init(const BITMAPINFOHEADER *in, int format);
	void ClearBuffer();
	bool Decompress(LPVOID inputBuffer, DWORD len, DWORD flags);
	void Inform(LPCSTR szText);
};


#endif	// _VIDEOCODEC_H_

