#ifndef _WINFILE_H_
#define _WINFILE_H_


class WinFile {

private:
	enum { WF_BUFFERSIZE = 65536 };

	BYTE            m_Buffer[WF_BUFFERSIZE];
	LARGE_INTEGER   m_Pos;
	LARGE_INTEGER   m_Size;
	HANDLE          m_hFile;

	void            Refresh();
	bool            Open(HANDLE h);

public:
	WinFile();
	~WinFile();

	static char *WcharToAnsi(const wchar_t *lpszWchar);

	bool     OpenA(const char *lpFileName);
	bool     OpenW(const wchar_t *lpFileName);

	__int64  Size()      const { return m_Size.QuadPart; }
	__int64  Pos()       const { return m_Pos.QuadPart; }

	bool     EndOfFile() const { return (m_Pos.QuadPart >= m_Size.QuadPart); }

	bool     Seek(__int64 iAbsPos);
	bool     Move(int iDelta)  { return Seek(m_Pos.QuadPart + iDelta); }
	int      Read(void *lpBuffer, int nBytes);
	int      NextByte();
};

#endif	// _WINFILE_H_

